#!/usr/bin/env bash

## allpairs ##

SOLVER_OPTS="-progress -ppverb=1 -allpairs -no-pp_ve -no-pp_ee"

DIR=$(dirname $0)
#COL2PB=/home/fs5/common/DB/project/icgca/icgca.py
COL2PB=$DIR/col_to_pb.py
COL_OPTS="-st 1"

NAPS=$DIR/naps-1.02b5
COUNTER=$DIR/pathcount_beta
PYTHON=python3

INPUTFILE=$1
BASENAME=`basename $1`
CNFFILE=${BASENAME%.*}.cnf
COSFILE=${BASENAME%.*}.cos
PBFILE=${BASENAME%.*}.pb

trap "rm -f $CNFFILE $COSFILE $PBFILE" EXIT 2 3 6 11 15

# (1) get statistics
NODES=`grep "^p" $INPUTFILE | cut -d' ' -f3`
EDGES=`grep "^p" $INPUTFILE | cut -d' ' -f4`
EDGES=$((EDGES * 2))
LLINE=`grep "^l" $INPUTFILE`

# (2) make pbfile from col
echo "$PYTHON $COL2PB $INPUTFILE $COL_OPTS "
$PYTHON $COL2PB $INPUTFILE $COL_OPTS > $PBFILE

# (3) make cnffile and cosfile from pbfile
echo "$NAPS -cnf=$CNFFILE "
$NAPS -cnf=$CNFFILE $PBFILE

echo "p map ${NODES} ${EDGES}" > $COSFILE
grep "^cv" $CNFFILE | sed -E 's/^cv//' | sed -E 's/ [0-9]+:[^R]\([^ ]+//g' | sed -E 's/ ([0-9]+):R\(([0-9]+),([0-9]+)\)/\1 \2 \3\n/g' >> $COSFILE
grep "^cv" $CNFFILE | sed -E 's/^cv//' | sed -E 's/ [0-9]+:[^S]\([^ ]+//g' | sed -E 's/ ([0-9]+):S\(([0-9]+)\)/s \1 \2\n/g' >> $COSFILE
echo $LLINE >> $COSFILE

# (4) run counter
$COUNTER $SOLVER_OPTS $CNFFILE $COSFILE

exit 0
