#!/usr/bin/env bash

## onepair ##

SOLVER_OPTS="-ppverb=1"

COL2PB=col_to_pb.py
#COL_OPTS="-dijk 1 -c 1"
COL_OPTS="-dijk 1 -c 1 -del_end 1"

DIR=$(dirname $0)
NAPS=$DIR/naps-1.02b5
COUNTER=$DIR/pathcount_gamma
#COUNTER=/home/fs5/common/DB/project/icgca/pathcount_gamma/graphpathcounter/pathcount-old.230628
PYTHON=python3

INPUTFILE=$1
BASENAME=`basename $1`
CNFFILE=${BASENAME%.*}.cnf
COSFILE=${BASENAME%.*}.cos
PBFILE=${BASENAME%.*}.pb

trap "rm -f $CNFFILE $COSFILE $PBFILE" EXIT 2 3 6 11 15

# (1) get statistics
NODES=`grep "^p" $INPUTFILE | cut -d' ' -f3`
EDGES=`grep "^p" $INPUTFILE | cut -d' ' -f4`
EDGES=$((EDGES * 2))
TLINE=`grep "^t" $INPUTFILE`
LLINE=`grep "^l" $INPUTFILE`

# (2) make pbfile from col
#$PYTHON $COL2PB $INPUTFILE > $PBFILE
$PYTHON $COL2PB $INPUTFILE $COL_OPTS > $PBFILE

# (3) make cnffile and cosfile from pbfile
$NAPS -cnf=$CNFFILE $PBFILE

echo "p map ${NODES} ${EDGES}" > $COSFILE
grep "^cv" $CNFFILE | sed -E 's/^cv//' | sed -E 's/ [0-9]+:[^R]\([^ ]+//g' | sed -E 's/ ([0-9]+):R\(([0-9]+),([0-9]+)\)/\1 \2 \3\n/g' >> $COSFILE
echo $TLINE >> $COSFILE
echo $LLINE >> $COSFILE

# (4) run counter
$COUNTER $SOLVER_OPTS $CNFFILE $COSFILE

exit 0
