#ifndef CONFIG_H_
#define CONFIG_H_

#include <string>
#include <float.h>
#include "utils/Options.h"

namespace GraphPC {

using namespace Glucose;

struct ConfigCounter {
	bool backjump;
	double bj_threshold;
	bool remove_sat_cls;
	bool rmvsatcl_threshold;
	bool restart;
	bool doPreprocss;
	bool cache;
	int cachesize;
	std::string pp_outfile;
	std::string map_outfile;
	std::string graph_outfile;
	bool allpairs;
	bool progressbar;
	// bool preprocess;
};

struct ConfigPreprocessor {
	int varlimit;
	double timelim;
	double reps;
	int verb;

	// SAT
	int64_t confl_budget;

	// EE
	bool ee;
	int ee_varlim;

	// VE/DefVE
	bool ve;
	int ve_reps;
	int dve_reps;
	bool ve_more;
	double dve_timelimit;

	// CS
	bool cs;
};

class Configuration {
public:
	ConfigCounter cntr;
	ConfigPreprocessor pp;

	Configuration();
	~Configuration() { }
};
}
#endif /* CONFIG_H_ */
